--[[
Name: AlarWidgets-3.0
Revision: $Rev: 408 $
Author: Alar of Daggerspine
Email: alar@aspide.it
Website: http://wow.aspide.it
Documentation: http://wiki.wowace.com/wiki/AlarLib-3.0
SVN: $HeadUrl:$
Description: Generic library
Dependencies: Ace3
License: LGPL v2.1
--]]
local MAJOR_VERSION = "AlarWidgets-3.0"
local MINOR_VERSION = tonumber(string.sub("$Revision: 408 $", 12, -3)) +1000
local function pp(msg) -- Minimal output function
	if (not ALARDEVELOPMENTPC) then return end
    DEFAULT_CHAT_FRAME:AddMessage("c0000ff00pp->|r" .. tostring(msg),1,0.5,0.2)
end
local __FILE__=tostring(debugstack(1,2,0):match("(.*):1"))
if (ALARDEVELOPMENTPC) then
DEFAULT_CHAT_FRAME:AddMessage(MAJOR_VERSION .. " from file " .. __FILE__)
end
pp("Loading " .. MAJOR_VERSION .. " r" .. MINOR_VERSION)
if (not LibStub) then
    DEFAULT_CHAT_FRAME:AddMessage("Couldn't find LibStub. Please reinstall " .. MAJOR_VERSION )
end
local lib,old=LibStub:NewLibrary(MAJOR_VERSION,MINOR_VERSION)
if (not lib) then
    pp("Already loaded a newer or equal version of " .. MAJOR_VERSION)
    return -- Already loaded
end
if (old) then
    pp(format("Upgrading %s from %s to %s",MAJOR_VERSION,old,MINOR_VERSION))
end
-----------------------------------------------------------------------------
lib.widgets=lib.widgets or {}
local AceGUI = LibStub("AceGUI-3.0")
lib.AceGUI=AceGUI
lib.L=AlarGetLocale()
lib.pp=pp
pp('Caricato L',L)
local WidgetVersion=MINOR_VERSION-65432
function lib:IterateWidgets() return pairs(self.widgets) end
----------------
-- Main Frame --
----------------
do
	local proto={}
	function proto:ApplyStatus(this)
		return
	end
	function proto.Status(this)
		if (this.obj) then
			return this.obj.status or this.obj.localstatus
		else
			return this.status or this.localstatus
		end
	end
	function proto:SetStatusTable(status)
		assert(type(status) == "table")
		pp(self.type,status,status.position)
		self.status = status
		self:ApplyStatus()
	end
	function proto:Show()
		self.frame:Show()
	end
	function proto:Hide()
		self.frame:Hide()
	end
	function proto:Acquire()
		self.frame:SetParent(UIParent)
		self.frame:SetFrameStrata("FULLSCREEN_DIALOG")
		self:ApplyStatus()
	end
	
	function proto:Release()
		self.status = nil
		for k in pairs(self.localstatus) do
			self.localstatus[k] = nil
		end
	end
	
	function proto:SetLocked(lock)
		local status = self.status or self.localstatus
		local old=status.locked
		status.locked=lock
		self:Lock()
		return old
	end
	function proto:GetLocked()
		local status = self.status or self.localstatus
		return status.locked
	end
	function lib.InjectStandardMethods(target)
	    for k,v in pairs(proto) do
	        target[k]=v
	    end
	    if (not target.localstatus) then
	    	target.localstatus={}
	    end
	end
end
function lib:CreatePanel()
    AceGUI:Create('AlarPanel')
end
function lib:CreateConfig()
    AceGUI:Create('AlarConfig')
end
function lib:CreateMiniMap()
    AceGUI:Create('AlarMinimapButton')
end
function lib:CreateCastButton()
    AceGUI:Create('AlarCastButton')
end
------------------------- Helpers -----
